

// 29 July 2019
// sketch for use with Android App 'DCC Railway'using IBT_2 h-bridge

#include <SoftwareSerial.h>

SoftwareSerial bluetooth(8,9);  // RX TX
int C;
int sensorValue;
long t = 0;
long lastmillis = 0;
long interval = 1000;
String inString;
int a[8];
int preamable_type = 0;
int Address;


// use digital pins 6 and 5 for DCC out

//Timer frequency is 2MHz for ( /8 prescale from 16MHz )
#define TIMER_SHORT 0x8D  // 58usec pulse length 
#define TIMER_LONG  0x1B  // 116usec pulse length 

unsigned char last_timer=TIMER_SHORT;  // store last timer value
   
unsigned char flag=0;  // used for short or long pulse
unsigned char every_second_isr = 0;  // pulse up or down

// definitions for state machine 
#define PREAMBLE 0    
#define SEPERATOR 1
#define SENDBYTE  2

unsigned char state= PREAMBLE;
unsigned char preamble_count = 16;
unsigned char outbyte = 0;
unsigned char cbit = 0x80;


// variables

unsigned char  xdata = 0, data = 0, data_f = 0,data_f1 = 0,data_f2 = 0;

int locoAdr = 9;   // this is the default address of the loco

// buffer for command
struct Message {
   unsigned char data[7];
   unsigned char len;
} ;

#define MAXMSG 3
// for the time being, use only 2 messages - the idle msg, the loco Speed msg, function msg

struct Message msg[MAXMSG] = { 
    { { 0xFF, 0, 0xFF, 0, 0, 0, 0}, 3},   // idle msg
    { { locoAdr, 0, 0,  0, 0, 0, 0}, 3}   // locoMsg with 128 speed steps 0x3f
  };               // loco msg must be filled later with speed and XOR data byte
                                
int msgIndex=0;  
int byteIndex=0;


//Setup Timer2.
//Configures the 8-Bit Timer2 to generate an interrupt at the specified frequency.
//Returns the time load value which must be loaded into TCNT2 inside your ISR routine.

void SetupTimer2(){
  //Timer2 Settings: Timer Prescaler /8, mode 0
  //Timmer clock = 16MHz/8 = 2MHz oder 0,5usec
  TCCR2A = 0;
  TCCR2B = 0<<CS22 | 1<<CS21 | 0<<CS20; 

  //Timer2 Overflow Interrupt Enable   
  TIMSK2 = 1<<TOIE2;

  //load the timer for its first cycle
  TCNT2=TIMER_SHORT; 
}
//Timer2 overflow interrupt vector handler
ISR(TIMER2_OVF_vect) {
  //Capture the current timer value TCTN2. This is how much error we have
  //due to interrupt latency and the work in this function
  //Reload the timer and correct for latency.  
  // for more info, see http://www.uchobby.com/index.php/2007/11/24/arduino-interrupts/
  unsigned char latency;
  // for every second interupt just toggle signal
  if (every_second_isr)  {
    PORTD = B01000000;  //use this instead of digitalWrite(6,1); digitalWrite(5,0);
     every_second_isr = 0;        
     // set timer to last value
     latency=TCNT2;
     TCNT2=latency+last_timer;  
  }  else  {  // != every second interrupt, advance bit or state
     PORTD = B00100000;  //digitalWrite(6,0); digitalWrite(5, 1)
     every_second_isr = 1; 
     switch(state)  {
       case PREAMBLE:
           flag=1; // short pulse
           preamble_count--;
           if (preamble_count == 0)  {  // advance to next state
              state = SEPERATOR;
              // get next message
              msgIndex++;
              if (msgIndex >= MAXMSG)  {  msgIndex = 0; }  
              byteIndex = 0; //start msg with byte 0
           }
           break;
        case SEPERATOR:
           flag=0; // long pulse
           // then advance to next state
           state = SENDBYTE;
           // goto next byte ...
           cbit = 0x80;  // send this bit next time first         
           outbyte = msg[msgIndex].data[byteIndex];
           break;
        case SENDBYTE:
           if (outbyte & cbit)  { 
              flag = 1;  // send short pulse
           }  else  {
              flag = 0;  // send long pulse
           }
           cbit = cbit >> 1;
           if (cbit == 0)  {  // last bit sent, is there a next byte?
              byteIndex++;
              if (byteIndex >= msg[msgIndex].len)  {
                 // this was already the XOR byte then advance to preamble
                 state = PREAMBLE;
                if (preamable_type == 0){
                 preamble_count = 16;    // normal preamble length of 16 '1's
                 }
                if (preamable_type == 1){
                 preamble_count = 24;    // preamble of 24 '1's for CV1 write
                 }
              }  else  {
                 // send separtor and advance to next byte
                 state = SEPERATOR ;
              }
           }
           break;
     }   
     if (flag)  {  // if data==1 then short pulse
        latency=TCNT2;
        TCNT2=latency+TIMER_SHORT;
        last_timer=TIMER_SHORT;
     }  else  {   // long pulse
        latency=TCNT2;
        TCNT2=latency+TIMER_LONG; 
        last_timer=TIMER_LONG;
     }  
  }
}


void setup(){
Serial.begin(115200);
analogReference(INTERNAL);
pinMode(13, OUTPUT);   

 bluetooth.begin(9600);
    delay(500); // wait for bluetooth module to start
    Serial.println("Bluetooth Started");  
    bluetooth.println("Bluetooth Started");

DDRD = B01100000;   //  register D5 for digital pin 5, D6 for digital pin 6 
 //Start the timer 
  SetupTimer2();
t = millis();
lastmillis = millis();
digitalWrite(13, LOW); // turn bridge o/p off

}

void current(){
int i;
  int value = 0;
  int numReadings = 5;
for (i = 0; i < numReadings; i++){
    // Read sensor data.
    value = value + analogRead(A0);
    // 1ms pause adds more stability between reads.
    delay(1);
  }

  sensorValue = value/numReadings;
  // Convert the analog reading (which goes from 0 - 1023) to a voltage (0 - 1.1V) = 1.08mv per division
  // 0.1 ohm resistor on current sense gives 200mv at 2 Amps or, 100mv per Amp
  // 1.08 mv per div for Internal Ref of 1.1v  : 100/1.08 = 92.6 divisions per 1000mA or 1 div = 10.8mA
  C = 10.8 * sensorValue ;  // mA
 
  if(C >4000){  // 4 amps
   Serial.println("Over Current");
   bluetooth.println("Short!");
   digitalWrite(13, LOW); // output off
   bluetooth.println(C);  
  }
}

void send_c(){
    t = millis() - lastmillis;  
if (t >= interval){
    //Serial.println(C);
    if(bluetooth.available() == true);{
       bluetooth.println(C);
       }
    lastmillis = millis();
    }
}

void loop() { 
      
  if(bluetooth.available() == true);
    {
        inString = bluetooth.readStringUntil('\n');
        Serial.println(inString);
    }
    if (inString.substring(0,1) == "D"){
    string(); }
            // incoming DCC packet
    if (inString.substring(0,1) == "C"){
      digitalWrite(13, HIGH); }
            // reset after over current, logic control of DCC signal on,brake off
    if (inString.substring(0,1) == "G"){
      digitalWrite(13, HIGH);
           current(); 
           bluetooth.println(C);
           Serial.print("current = ");Serial.println(C);
           }
            // request for load current value 
    if (inString.substring(0,1) == "A"){
       digitalWrite(13, HIGH); 
       get_cv_data();
       cv1_prog();
       check_cv(); 
       digitalWrite(13, LOW);}  
    if (inString.substring(0,1) == "V"){
      delay(50);bluetooth.print("CV1 updated"); 
      Serial.println(Address);}
            // cv1 write  
    if (inString.substring(0,1) == "E"){
       digitalWrite(13, LOW); // output off
            }   // e-stop
    inString = "";
   }

void check_cv(){
    a[1] = Address;
    a[2] = 63;
    a[3] = 50;
    amend_len4(msg[1]);
    assemble_4_byte();
    delay(500); 
    current();
    delay(30);
    a[3] = 1;
    amend_len4(msg[1]);
    assemble_4_byte();  
       Serial.print("CV1, ");
       Serial.print(Address);
       Serial.print(" current = ");
       Serial.println(C); 
 }
   
 void get_cv_data(){
    unsigned long z = inString.length();
    int y = 0;
    int count = 0;    
    String inChar;
    String temp ="";
   for (int i = 0; i<=z; i++){
    inChar = inString.substring(i,i+1);
    if (inChar == ",") {count++;}
    if (inChar != "," && inChar != "A") {temp += inChar;}
    if (inChar == ",") {Address = (temp.toInt());y = y +1;temp = "";}
       }
    amend_len3(msg[1]); 
    assemble_3_byte(); 
    Serial.println(inString);
   }
 
void string(){
    unsigned long z = inString.length();
    int y = 0;
    for (int i = 0; i<=5; i++){
      a[i] = 0;
    }
int count = 0;    
String inChar;
String temp ="";
   for (int i = 0; i<=z; i++){
    inChar = inString.substring(i,i+1);
    if (inChar == ",") {
      count++;
    }
    if (inChar != "," && inChar != "D") {
      temp += inChar;
    }
    if (inChar == ",") {
      a[y] = (temp.toInt());
      y = y +1;
      temp = "";
    }
   }
    
    if (count == 3){  
      //Serial.println(inString);
      //print_data();
    amend_len3(msg[1]); 
    assemble_3_byte(); 
    }
    if (count == 4){  
     //Serial.println(inString);
     //print_data();
    amend_len4(msg[1]);
    assemble_4_byte(); 
    } 
    //Serial.println(inString);
    //Serial.println(a[1]);
    // Serial.println(a[2]);
    //Serial.println(a[3]);
    //Serial.println(a[4]);
    //print_data();  
    }
  
 void amend_len4 (struct Message & x) 
{ 
 x.len = 4;
   //Serial.println(x.len);
}

void assemble_4_byte() { 
   noInterrupts(); 
   msg[1].data[0] = a[1]; 
   msg[1].data[1] = a[2];
   msg[1].data[2] = a[3];
   msg[1].data[3] = ((a[1] ^ a[2])^ a[3]);
   interrupts();
}

void amend_len3 (struct Message & x) 
{ 
 x.len = 3;
  //Serial.println(x.len);
}

void assemble_3_byte() { 
   noInterrupts(); 
   msg[1].data[0] = a[1];
   msg[1].data[1] = a[2];
   msg[1].data[2] = (a[1] ^ a[2]);
   msg[1].data[3] = 0; 
   interrupts();
   
}


void print_data(){
 Serial.print(msg[1].data[0], DEC);
 Serial.print(",");
 Serial.print(msg[1].data[1], DEC);
 Serial.print(",");
 Serial.print(msg[1].data[2], DEC);
 Serial.print(",");
 Serial.print(msg[1].data[3], DEC);
 Serial.println(",");
  }

//CV1 coding

void cv1_prog(){
for (int i = 0 ; i<=3 ; i++){
  reset_packet();
  delay(10);
 }
for (int i = 0 ; i<=5 ; i++){
  page_preset_packet();
  delay(10);
 }

for (int i = 0 ; i<=9 ; i++){
  reset_packet();
  delay(10);
 } 
for (int i = 0 ; i<=5 ; i++){
  cv1_write_packet();
  delay(10);
 } 
for (int i = 0 ; i<=10 ; i++){
  cv1_write_packet();
  delay(10);
 } 
}


void reset_packet() {
   noInterrupts();
   preamable_type = 0;
   msg[0].data[0] = B11111111;
   msg[0].data[1] = B11111111;
   msg[0].data[2] = B00000000;
   msg[1].data[0] = B00000000;
   msg[1].data[1] = B00000000;
   msg[1].data[2] = B00000000; 
   interrupts();
}
void page_preset_packet() {
   noInterrupts();
   preamable_type = 0; // 16 x '1's
   msg[0].data[0] = B11111111;
   msg[0].data[1] = B11111111;
   msg[0].data[2] = B00000000;
   msg[1].data[0] = B01111101;
   msg[1].data[1] = B00000001;
   msg[1].data[2] = B01111100; 
   interrupts();
}
void cv1_write_packet() { 
   noInterrupts();
   preamable_type = 1;  // 24 x '1's
   msg[0].data[0] = B11111111;
   msg[0].data[1] = B11111111;
   msg[0].data[2] = B11111111;
   msg[1].data[0] = B01111000; // Address only mode
   msg[1].data[1] = B00000000 | Address;
   msg[1].data[2] = (msg[1].data[0] ^ msg[1].data[1]);
   interrupts();
}


  
